from AccessControl.Permissions import add_user_folders

from Products.Archetypes import process_types
from Products.Archetypes.public import listTypes

from Products.CMFCore.utils import ContentInit, ToolInit
from Products.CMFCore.CMFCorePermissions import AddPortalContent as ADD_CONTENT_PERMISSION

from Products.PluggableAuthService import registerMultiPlugin

from Products.Membrane import config

from Products.Membrane.plugins import MembraneUserManager, MembraneGroupManager, \
    MembranePropertyManager, MembraneRoleManager, MembraneUserFactory

registerMultiPlugin( MembraneUserManager.MembraneUserManager.meta_type )
registerMultiPlugin( MembraneGroupManager.MembraneGroupManager.meta_type )
registerMultiPlugin( MembranePropertyManager.MembranePropertyManager.meta_type )
registerMultiPlugin( MembraneRoleManager.MembraneRoleManager.meta_type )
registerMultiPlugin( MembraneUserFactory.MembraneUserFactory.meta_type )


def initialize(context):

    from Products.Membrane import types

    if config.INSTALL_TEST_TYPES:
        import examples

    content_types, constructors, ftis = process_types(listTypes(config.PROJECTNAME), config.PROJECTNAME)

    ContentInit(
        config.PROJECTNAME + ' Content',
        content_types = content_types,
        permission = ADD_CONTENT_PERMISSION,
        extra_constructors = constructors,
        fti = ftis,
        ).initialize(context)

    context.registerClass( MembraneUserManager.MembraneUserManager,
                           permission = add_user_folders,
                           constructors = ( MembraneUserManager.manage_addMembraneUserManagerForm,
                                            MembraneUserManager.addMembraneUserManager ),
                           visibility = None
                           )

    context.registerClass( MembraneGroupManager.MembraneGroupManager,
                           permission = add_user_folders,
                           constructors = ( MembraneGroupManager.manage_addMembraneGroupManagerForm,
                                            MembraneGroupManager.addMembraneGroupManager ),
                           visibility = None
                           )

    context.registerClass( MembranePropertyManager.MembranePropertyManager,
                           permission = add_user_folders,
                           constructors = ( MembranePropertyManager.manage_addMembranePropertyManagerForm,
                                            MembranePropertyManager.addMembranePropertyManager ),
                           visibility = None
                           )

    context.registerClass( MembraneRoleManager.MembraneRoleManager,
                           permission = add_user_folders,
                           constructors = ( MembraneRoleManager.manage_addMembraneRoleManagerForm,
                                            MembraneRoleManager.addMembraneRoleManager ),
                           visibility = None
                           )

    context.registerClass( MembraneUserFactory.MembraneUserFactory,
                           permission = add_user_folders,
                           constructors = ( MembraneUserFactory.manage_addMembraneUserFactoryForm,
                                            MembraneUserFactory.addMembraneUserFactory ),
                           visibility = None
                           )

    from Products.Membrane.tools import MembraneTool
    ToolInit(
            config.PROJECTNAME+ ' Tool',
            tools = (MembraneTool.MembraneTool, ),
            product_name = config.PROJECTNAME,
            icon = 'tool.gif'
        ).initialize(context)
