from Testing import ZopeTestCase
#from Products.Membrane import examples
from Products.Membrane.tests import dummy
from Products.Membrane.config import TOOLNAME

from Products.CMFPlone.utils import _createObjectByType

# Make the boring stuff load quietly
ZopeTestCase.installProduct('Membrane')

from Products.PlonePAS.tests import PloneTestCase


class MembraneTestCase(PloneTestCase.PloneTestCase):

    class Session(dict):
        def set(self, key, value):
            self[key] = value

    def _setup(self):
        PloneTestCase.PloneTestCase._setup(self)
        self.portal.portal_quickinstaller.installProduct('Membrane')
        mtool = getattr(self.portal, TOOLNAME)
        mtool.registerMembraneType(dummy.TestMember.portal_type)
        mtool.registerMembraneType(dummy.AlternativeTestMember.portal_type)
        mtool.registerMembraneType(dummy.TestGroup.portal_type)
        self.app.REQUEST['SESSION'] = self.Session()

    def addUser(self, obj=None):
        if obj is None:
            obj = self.portal
        self.member = _createObjectByType('TestMember', obj, 'testuser')
        self.member.setUserName('testuser')
        self.member.setPassword('testpassword')
        self.member.setFullname('full name')
        self.member.reindexObject()

    def addGroup(self, obj=None):
        if obj is None:
            obj = self.portal
        self.group = _createObjectByType('TestGroup', obj, 'testgroup')
        self.group.setTitle('Test group')
        self.group.setGroupName('testgroup')
        self.group.reindexObject()
