#
# MembraneTestCase Membrane
#

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
from Products.Membrane.tests import MembraneTestCase
from Products.Membrane.config import TOOLNAME, INSTALL_TEST_TYPES
from AccessControl import getSecurityManager
from AccessControl.SecurityManagement import setSecurityManager

# To catch syntax errors in Install
from Products.Membrane.Extensions import Install


class TestProductInstall(MembraneTestCase.MembraneTestCase):

    def afterSetUp(self):
        pass

    def testProductInstall(self):
        self.failUnless(self.portal.portal_quickinstaller.isProductInstalled('Membrane'))

    def testTypesInstall(self):
        typeslist = ['Member']
        for t in typeslist:
            self.failUnless(t in self.portal.portal_types.objectIds(), '%s content type not installed' % t)

    if INSTALL_TEST_TYPES:
        def testExampleTypesInstall(self):
            typeslist = ['SimpleMember', 'SimpleGroup']
            for t in typeslist:
                self.failUnless(t in self.portal.portal_types.objectIds(), '%s content type not installed' % t)

    def testTestTypesInstall(self):
        typeslist = ['TestMember', 'AlternativeTestMember', 'TestGroup']
        for t in typeslist:
            self.failUnless(t in self.portal.portal_types.objectIds(), '%s content type not installed' % t)

    def testToolInstall(self):
        self.failUnless(TOOLNAME in self.portal.objectIds())


def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestProductInstall))
    return suite

if __name__ == '__main__':
    framework()
